﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public BANAno As BANano
	' we define an event type
	Type EventObject(ElementName As String, EventType As String, CallBackMethod As String)
	'the map will hold all events for elements
	Public Events As Map
End Sub

Sub Init()
	BANAno.GetElement("#body").Empty
	BANAno.GetElement("#body").Append($"<button id="btnok">Button Itself</button><br>"$)
	BANAno.GetElement("#body").Append($"<button id="btnok-icon">Assumed Icon</button><br>"$)
	BANAno.GetElement("#body").Append($"<button id="btnok-span">Assumed Span</button><br>"$)
	BANAno.GetElement("#body").Append($"<button id="btnok-img">Assumed Img</button><br>"$)
	BANAno.GetElement("#body").Append($"<a id="btnhave">Anchor</a><br>"$)
	'add events for each element
	' clear events
	' Events.Initialize
	AddEvent("btnok","click","btnok_click")
	AddEvent("btnhave","click","btnhave_click")
	'bind the events to each element
	BindEvents("globalEvent",Me)
	'BindEvents("",Me)
End Sub

Sub btnok_click(event As BANanoEvent)
	Log(event.ID)
End Sub


Sub btnhave_click(event As BANanoEvent)
	Log(event.ID)
End Sub

Sub globalEvent(event As BANanoEvent)
	Log(" ** global event handler ***")
	Log(event.ID)
End Sub

''add an event to the collection
Sub AddEvent(ElementID As String, EventType As String,CallBackMethod As String)
	ElementID = ElementID.ToLowerCase
	ElementID = ElementID.Trim
	Dim evnt As EventObject
	evnt.Initialize
	evnt.ElementName = ElementID
	evnt.EventType = EventType
	evnt.CallBackMethod = CallBackMethod
	Events.Put(ElementID,evnt)
	Dim em As List
	em.Initialize
	em.Add("icon")
	em.Add("img")
	em.Add("badge")
	em.Add("title")
	em.Add("span")
	Dim lTot As Int = em.Size - 1
	Dim lCnt As Int
	For lCnt = 0 To lTot
		Dim strsuffix As String = em.Get(lCnt)
		Dim strkey As String = $"${ElementID}-${strsuffix}"$
		Dim evnt As EventObject
		evnt.Initialize
		evnt.ElementName = strkey
		evnt.EventType = EventType
		evnt.CallBackMethod = CallBackMethod
		Events.Put(strkey,evnt)
	Next
End Sub


'banano bind the events to elements
Sub BindEvents(elMethod As String, EventHandler As Object)
	Dim mTot As Int = Events.Size - 1
	Dim mCnt As Int
	For mCnt = 0 To mTot
		Dim elID As String = Events.GetKeyAt(mCnt)
		Dim elEvent As EventObject = Events.Get(elID)
		Dim btnEvent As String = elEvent.CallBackMethod
		Dim evType As String = elEvent.EventType
		Dim elKey As String = $"#${elID}"$
		'these call a universal method
		If elMethod <> "" Then
			btnEvent = elMethod.tolowercase
		End If
		If EventHandler <> Null Then
			Dim eExist As Boolean = BANAno.Exists(elKey)
			If eExist = True Then
				Dim elm As BANanoElement = BANAno.GetElement(elKey)
				elm.HandleEvents(evType, EventHandler, btnEvent)
			End If
		End If
	Next
End Sub